
/**
 * <Buffer > Binary data type
 * @typedef {TypedArray} Buffer
 * @global
 * @example
 * <Buffer 5b ed 67 f9 9c b3 31 9e 0c 6f 6a 03 54 8b e3 c8 c5 2a 83 64 46 4f 88 6f> 24
 */

/**
 * Client password or passphrase.
 * @typedef {String} Password
 * @global
 * @example
 * "password0192837465DlK" || "It's my secret phrase"
 */

/**
 * Hex-string
 * @typedef {String} HexString
 * @global
 * @example
 * "n1QZMXSZtW7BUerroSms4axNfyBGyFGkrh5";
 */

 /**
 * Base64 encoded string
 * @typedef {String} Base64
 * @global
 * @example
 * "OGQ5NjllZWY2ZWNhZDNjMjlhM2E2MjkyODBlNjg2Y2YwYzNmNWQ1YTg2YWZmM2NhMTIwMjBjOTIzYWRjNmM5Mg==";
 */

/**
 * Hex-string or Buffer hash.
 * @typedef {(String|Buffer)} Hash
 * @global
 * @example
 * "n1QZMXSZtW7BUerroSms4axNfyBGyFGkrh5" || <Buffer 5b ed 67 f9 9c b3 31 9e 0c 6f 6a 03 54 8b e3 c8 c5 2a 83 64 46 4f 88 6f> 24;
 */

 /**
 * UInt32 Structure.
 * @typedef {Number} UInt32
 * @global
 * @example
 * 10
 */

