
"use strict";

var API = require("./api.js");
var Admin = require("./admin.js");

var Unit = require("./utils/unit.js");

/**
 * Zom API library constructor.
 * @constructor
 * @param {Request} request - transport wrapper.
 */
var Zom = function (request) {
	if (request) {
		this._request = request;
	}

	this.api = new API(this);
	this.admin = new Admin(this);
};

Zom.prototype.setRequest = function (request) {
	this._request = request;
	this.api._setRequest(request);
	this.admin._setRequest(request);
};

Zom.prototype.toBasic = Unit.toBasic;
Zom.prototype.fromBasic = Unit.fromBasic;
Zom.prototype.zomToBasic = Unit.zomToBasic;

module.exports = Zom;
